Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkAbstractPicker Class Reference

`#include <vtkAbstractPicker.h>`

Inheritance diagram for vtkAbstractPicker:

[legend]
Collaboration diagram for vtkAbstractPicker:

[legend]
List of all members.

## Detailed Description

define API for picking subclasses

Date:
  2002/05/28 03:33:50

Revision:
  1.11

vtkAbstractPicker is an abstract superclass that defines a minimal API for its concrete subclasses. The minimum functionality of a picker is to return the x-y-z global coordinate position of a pick (the pick itself is defined in display coordinates).

The API to this class is to invoke the Pick() method with a selection point (in display coordinates - pixels) and a renderer. Then get the resulting pick position in global coordinates with the GetPickPosition() method.

vtkPicker has hooks for methods to call during the picking process. These methods are StartPickMethod(), PickMethod(), and EndPickMethod() which are invoked prior to picking, when something is picked, and after all picking candidates have been tested. Note that during the pick process the PickMethod() of vtkProp (and its subclasses such as vtkActor) is called prior to the pick method of vtkPicker.

Warning:
  vtkAbstractPicker and its subclasses will not pick props that are "unpickable" (see vtkProp) or are fully transparent (if transparency is a property of the vtkProp).

Warning:
  There are two classes of pickers: those that pick using geometric methods (typically a ray cast); and those that use rendering hardware. Geometric methods return more information but are slower. Hardware methods are much faster and return minimal information. Examples of geometric pickers include vtkPicker, vtkCellPicker, and vtkPointPicker. Examples of hardware pickers include vtkWorldPointPicker and vtkPropPicker.

See also:
  vtkPropPicker uses hardware acceleration to pick an instance of vtkProp. (This means that 2D and 3D props can be picked, and it's relatively fast.) If you need to pick cells or points, you might wish to use vtkCellPicker or vtkPointPicker. vtkWorldPointPicker is the fastest picker, returning an x-y-z coordinate value using the hardware z-buffer. vtkPicker can be used to pick the bounding box of 3D props.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (85%)
  - Avila, Lisa (8%)

CVS logs (CVSweb):
  - .`cxx` (`/Rendering/vtkAbstractPicker.cxx)`
  - .`h` (`/Rendering/vtkAbstractPicker.h)`

Definition at line 81 of file vtkAbstractPicker.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetStartPickMethod (void(*f)(void *), void *arg)
void | SetPickMethod (void(*f)(void *), void *arg)
void | SetEndPickMethod (void(*f)(void *), void *arg)
void | SetStartPickMethodArgDelete (void(*f)(void *))
void | SetPickMethodArgDelete (void(*f)(void *))
void | SetEndPickMethodArgDelete (void(*f)(void *))
void | InitializePickList ()
void | AddPickList (vtkProp *)
void | DeletePickList (vtkProp *)
vtkPropCollection * | GetPickList ()
virtual vtkRenderer * | GetRenderer ()
virtual float * | GetSelectionPoint ()
virtual void | GetSelectionPoint (float data[3])
virtual float * | GetPickPosition ()
virtual void | GetPickPosition (float data[3])
virtual int | Pick (float selectionX, float selectionY, float selectionZ, vtkRenderer *renderer)=0
int | Pick (float selectionPt[3], vtkRenderer *ren)
virtual void | SetPickFromList (int)
virtual int | GetPickFromList ()
virtual void | PickFromListOn ()
virtual void | PickFromListOff ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkAbstractPicker * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkAbstractPicker ()
| ~vtkAbstractPicker ()
virtual void | Initialize ()
## Protected Attributes
vtkRenderer * | Renderer
float | SelectionPoint [3]
float | PickPosition [3]
unsigned long | StartPickTag
unsigned long | PickTag
unsigned long | EndPickTag
int | PickFromList
vtkPropCollection * | PickList

## Member Typedef Documentation

typedef vtkObject vtkAbstractPicker::Superclass

| Reimplemented from vtkObject. Reimplemented in vtkAbstractPropPicker, vtkCellPicker, vtkPicker, vtkPointPicker, vtkPropPicker, and vtkWorldPointPicker. Definition at line 84 of file vtkAbstractPicker.h.

## Constructor & Destructor Documentation

vtkAbstractPicker::vtkAbstractPicker | ( |  | ) | `[protected]`

vtkAbstractPicker::~vtkAbstractPicker | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkAbstractPicker::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject. Reimplemented in vtkAbstractPropPicker, vtkCellPicker, vtkPicker, vtkPointPicker, vtkPropPicker, and vtkWorldPointPicker.

int vtkAbstractPicker::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkAbstractPropPicker, vtkCellPicker, vtkPicker, vtkPointPicker, vtkPropPicker, and vtkWorldPointPicker.

virtual int vtkAbstractPicker::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject. Reimplemented in vtkAbstractPropPicker, vtkCellPicker, vtkPicker, vtkPointPicker, vtkPropPicker, and vtkWorldPointPicker.

vtkAbstractPicker* vtkAbstractPicker::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject. Reimplemented in vtkAbstractPropPicker, vtkCellPicker, vtkPicker, vtkPointPicker, vtkPropPicker, and vtkWorldPointPicker.

void vtkAbstractPicker::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject. Reimplemented in vtkAbstractPropPicker, vtkCellPicker, vtkPicker, vtkPointPicker, vtkPropPicker, and vtkWorldPointPicker.

virtual vtkRenderer* vtkAbstractPicker::GetRenderer | ( |  | ) | `[virtual]`

| Get the renderer in which pick event occurred.

virtual float* vtkAbstractPicker::GetSelectionPoint | ( |  | ) | `[virtual]`

| Get the selection point in screen (pixel) coordinates. The third value is related to z-buffer depth. (Normally should be =0.)

virtual void vtkAbstractPicker::GetSelectionPoint | ( | float | data[3] | ) | `[virtual]`

| Get the selection point in screen (pixel) coordinates. The third value is related to z-buffer depth. (Normally should be =0.)

virtual float* vtkAbstractPicker::GetPickPosition | ( |  | ) | `[virtual]`

| Return position in global coordinates of pick point.

virtual void vtkAbstractPicker::GetPickPosition | ( | float | data[3] | ) | `[virtual]`

| Return position in global coordinates of pick point.

virtual int vtkAbstractPicker::Pick | ( | float | selectionX,
|  | float | selectionY,
|  | float | selectionZ,
|  | vtkRenderer * | renderer
| ) | `[pure virtual]`

| Perform pick operation with selection point provided. Normally the first two values for the selection point are x-y pixel coordinate, and the third value is =0. Return non-zero if something was successfully picked. Implemented in vtkPicker, vtkPropPicker, and vtkWorldPointPicker. Referenced by vtkWorldPointPicker::Pick(), vtkPropPicker::Pick(), and vtkPicker::Pick().

int vtkAbstractPicker::Pick | ( | float | selectionPt[3],
|  | vtkRenderer * | ren
| ) | `[inline]`

| provided. Normally the first two values for the selection point are x-y pixel coordinate, and the third value is =0. Return non-zero if something was successfully picked. Reimplemented in vtkPicker, vtkPropPicker, and vtkWorldPointPicker. Definition at line 116 of file vtkAbstractPicker.h.

void vtkAbstractPicker::SetStartPickMethod | ( | void(* | f)(void *),
|  | void * | arg
| ) |

| begins.

void vtkAbstractPicker::SetPickMethod | ( | void(* | f)(void *),
|  | void * | arg
| ) |

| Specify function to be called when something is picked.

void vtkAbstractPicker::SetEndPickMethod | ( | void(* | f)(void *),
|  | void * | arg
| ) |

| Specify function to be called after all picking operations have been performed.

void vtkAbstractPicker::SetStartPickMethodArgDelete | ( | void(* | f)(void *) | ) |

| Set a method to delete user arguments for StartPickMethod.

void vtkAbstractPicker::SetPickMethodArgDelete | ( | void(* | f)(void *) | ) |

| Set a method to delete user arguments for PickMethod.

void vtkAbstractPicker::SetEndPickMethodArgDelete | ( | void(* | f)(void *) | ) |

| Set a method to delete user arguments for EndPickMethod.

virtual void vtkAbstractPicker::SetPickFromList | ( | int |  | ) | `[virtual]`

| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). Make sure that the pick list contains actors that referred to by the picker's renderer.

virtual int vtkAbstractPicker::GetPickFromList | ( |  | ) | `[virtual]`

| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). Make sure that the pick list contains actors that referred to by the picker's renderer.

virtual void vtkAbstractPicker::PickFromListOn | ( |  | ) | `[virtual]`

| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). Make sure that the pick list contains actors that referred to by the picker's renderer.

virtual void vtkAbstractPicker::PickFromListOff | ( |  | ) | `[virtual]`

| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). Make sure that the pick list contains actors that referred to by the picker's renderer.

void vtkAbstractPicker::InitializePickList | ( |  | ) |

| Initialize list of actors in pick list.

void vtkAbstractPicker::AddPickList | ( | vtkProp * |  | ) |

| Add an actor to the pick list.

void vtkAbstractPicker::DeletePickList | ( | vtkProp * |  | ) |

| Delete an actor from the pick list.

vtkPropCollection* vtkAbstractPicker::GetPickList | ( |  | ) | `[inline]`

| Return the list of actors in the PickList. Definition at line 158 of file vtkAbstractPicker.h.

virtual void vtkAbstractPicker::Initialize | ( |  | ) | `[protected, virtual]`

| Reimplemented in vtkAbstractPropPicker, vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker.

## Member Data Documentation

vtkRenderer* vtkAbstractPicker::Renderer`[protected]`

| Definition at line 166 of file vtkAbstractPicker.h.

float vtkAbstractPicker::SelectionPoint[3]`[protected]`

| Definition at line 167 of file vtkAbstractPicker.h.

float vtkAbstractPicker::PickPosition[3]`[protected]`

| Definition at line 168 of file vtkAbstractPicker.h.

unsigned long vtkAbstractPicker::StartPickTag`[protected]`

| Definition at line 171 of file vtkAbstractPicker.h.

unsigned long vtkAbstractPicker::PickTag`[protected]`

| Definition at line 172 of file vtkAbstractPicker.h.

unsigned long vtkAbstractPicker::EndPickTag`[protected]`

| Definition at line 173 of file vtkAbstractPicker.h.

int vtkAbstractPicker::PickFromList`[protected]`

| Definition at line 176 of file vtkAbstractPicker.h.

vtkPropCollection* vtkAbstractPicker::PickList`[protected]`

| Definition at line 177 of file vtkAbstractPicker.h.

The documentation for this class was generated from the following file:

- Rendering/vtkAbstractPicker.h